
var dlgSelectionStyleSetting = {

	get STRING()   { return document.getElementById("bitsHyperAnchorString"); },
	get PREVIEW() { return document.getElementById("dlgSelectionStyleSettingPreview"); },

	_preSlectedIndex : -1,
	_isEditMode : false,

	init : function(){
//alert("init");	
		document.documentElement.buttons = "accept,cancel";
		
		var prefSettings = unescape(nsPreferences.copyUnicharPref("hyperanchor.dlgSelectionStyleSetting.settingList", ""));
		var prefSettingAry = prefSettings ? prefSettings.split("\n") : new Array(0);
		for(var i = 0; i < prefSettingAry.length; i++){
			var key_val = prefSettingAry[i].split("\t");
			this.newSetting(key_val[0], key_val[1]);
		}
		var listElem = document.getElementById("markerSettingList");
		listElem.selectedIndex = 0;

		if(window.arguments && window.arguments[0] == 'dlgCalled') window.opener.bitsHyperAnchor._dlgCalled = true;
	},

	done : function(){
//alert("done");
try{
		if(this._isEditMode){
			this.select(true);
			return false;
		}
		
		var settingAry = [];
		var listElem = document.getElementById("markerSettingList");
		for(var i = 0; i < listElem.getRowCount(); i++){
			var itemElem = listElem.getItemAtIndex(i);
			var labelElem = itemElem.firstChild;
			settingAry.push(labelElem.value + "\t" + itemElem.getAttribute("hidden"));
		}
		var settingStr = settingAry.join("\n");

		nsPreferences.setUnicharPref("hyperanchor.dlgSelectionStyleSetting.settingList", escape(settingStr));

//		window.opener.bitsHyperAnchor.bookmarkSlectionWithStyleMenuLoad();

		return true;
}catch(e){
	alert(e);
}
	},

	update : function(){
//alert("update");
		this.PREVIEW.setAttribute("style", this.parseToString(true));
	},

	select : function(isForceSelect){
//alert("select");
try{
		var listElem = document.getElementById("markerSettingList");
		var selItemElem = listElem.selectedItem;
		
		// リストが選択されている場合スタイルを適用する
		if(selItemElem){
			var styleStr = selItemElem.getAttribute("hidden");
			this.parseFromString(styleStr);
		}

		// 前回選択位置が異なる場合、編集モードを終了して全てtextbox→labelに戻す
		if(isForceSelect || this._preSlectedIndex != listElem.selectedIndex){
			
			for(var i = 0; i < listElem.getRowCount(); i++){
				var itemElem = listElem.getItemAtIndex(i);
				var childElem = itemElem.firstChild;
				if(childElem.tagName == "textbox"){
					var labelElem = document.createElement("label");
					itemElem.appendChild(labelElem);
					this.labelSetting(labelElem, childElem.value);
					itemElem.removeChild(childElem);
					childElem = labelElem;
				}
				itemElem.setAttribute("style", "");
//				childElem.setAttribute("style", "");
			}
			this._isEditMode = false;
		}
		this._preSlectedIndex = listElem.selectedIndex;
}catch(e){
	alert(e);
}
	},

	clickListItem : function(){
//alert("clickListItem");
try{
		var listElem = document.getElementById("markerSettingList");
		var clickedItemElem = listElem.getItemAtIndex(this._preSlectedIndex);
		
		if(!this._isEditMode){
			
			clickedItemElem.setAttribute("style", "background:#fff;");
			
			var labelElem = clickedItemElem.firstChild;
			var settingName = labelElem.value;
			clickedItemElem.removeChild(labelElem);
			
			var textboxElem = document.createElement("textbox");
			textboxElem.setAttribute("style", "width:190px;");
			clickedItemElem.appendChild(textboxElem);
			this.textboxSetting(textboxElem, settingName);
			
			this._isEditMode = true;
		}
}catch(e){
	alert(e);
}
	},

	checkChangedListItem : function(){
//alert("checkChangedListItem");
try{
		var listElem = document.getElementById("markerSettingList");
		var changedItemElem = listElem.getItemAtIndex(this._preSlectedIndex);
		var changedChildElem = changedItemElem.firstChild;
		
		var itemCount = listElem.getRowCount();
		for(var i = 0; i >= 0; i++){
			if(itemCount <= i) i = -1;
			
			var childElem = listElem.getItemAtIndex(i).firstChild;
			if(this._preSlectedIndex != i && childElem.value == changedChildElem.value){
				changedChildElem.value += "_";
				i = -1;
				continue;
			}
			if(itemCount - 1 <= i) break;
		}
}catch(e){
	alert(e);
}
	},

	newSetting : function(settingName, styleStr){
//alert("newSetting");
try{
		var listElem = document.getElementById("markerSettingList");

		var itemElem = document.createElement("richlistitem");
		listElem.appendChild(itemElem);
		
		styleStr = styleStr ? styleStr : unescape(nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.defaultStyle", this.STRING.getString("DEFAULT_STYLE")));
		itemElem.setAttribute("hidden", styleStr);
		
		var labelElem = document.createElement("label");
		itemElem.appendChild(labelElem);
		this.labelSetting(labelElem, settingName);

		listElem.selectedItem = itemElem;

		this.checkChangedListItem();
}catch(e){
	alert(e);
}
	},

	labelSetting : function(labelElem, settingName){
try{
		labelElem.value = settingName ? settingName : "new setting";
//		labelElem.setAttribute("onclick", "dlgSelectionStyleSetting.clickListItem();");
		labelElem.setAttribute("onmousedown", "dlgSelectionStyleSetting.clickListItem();");
		labelElem.setAttribute("ondblclick", "dlgSelectionStyleSetting.clickListItem();");
}catch(e){
	alert(e);
}
	},

	textboxSetting : function(textboxElem, settingName){
try{
		textboxElem.value = settingName;
//		textboxElem.setAttribute("class", "plain");
		textboxElem.setAttribute("style", "width:190px;");
//		textboxElem.setAttribute("onclick", "dlgSelectionStyleSetting.clickListItem();");
		textboxElem.setAttribute("onmousedown", "dlgSelectionStyleSetting.clickListItem();");
		textboxElem.setAttribute("ondblclick", "dlgSelectionStyleSetting.clickListItem();");
		textboxElem.setAttribute("onchange", "dlgSelectionStyleSetting.checkChangedListItem();");
//		textboxElem.setSelectionRange(1, 1);
		textboxElem.select();
}catch(e){
	alert(e);
}
	},

	deleteSetting : function(){
//alert("deleteSetting");
		var listElem = document.getElementById("markerSettingList");
		var itemElem = listElem.selectedItem;
		var labelElem = itemElem.firstChild;

		if(listElem.selectedIndex < 0) return;
		
		listElem.removeChild(listElem.selectedItem);
		
		listElem.selectedIndex = this._preSlectedIndex >= listElem.getRowCount() ? this._preSlectedIndex - 1 : this._preSlectedIndex;
	},

	broadcast : function(){
//alert("broadcast");
		var ret = [
			document.getElementById("markerBackgroundEnabled").checked,
			document.getElementById("markerTextEnabled").checked,
			document.getElementById("markerBorderEnabled").checked,
			document.getElementById("markerIconEnabled").checked
		];
		document.getElementById("markerBroadcast0").setAttribute("disabled", !ret[0]);
		document.getElementById("markerBroadcast1").setAttribute("disabled", !ret[1]);
		document.getElementById("markerBroadcast2").setAttribute("disabled", !ret[2]);
		document.getElementById("markerBroadcast3").setAttribute("disabled", !ret[3]);
		return ret;
	},

	parseFromString : function(cssText){
//alert("parseFromString");
		this.PREVIEW.setAttribute("style", cssText);
		document.getElementById("markerTextBold").checked          = this.PREVIEW.style.fontWeight == "bold";
		document.getElementById("markerTextItalic").checked        = this.PREVIEW.style.fontStyle == "italic";
		document.getElementById("markerTextStrike").checked        = this.PREVIEW.style.textDecoration == "line-through";
		document.getElementById("markerBackgroundEnabled").checked = this.PREVIEW.style.backgroundColor;
		document.getElementById("markerTextEnabled").checked       = this.PREVIEW.style.color;
		document.getElementById("markerBorderEnabled").checked     = this.PREVIEW.style.borderBottom;

		var iconInfo = this.getIconStyle(cssText);
		document.getElementById("markerIconEnabled").checked = iconInfo["iconEnabled"];

		var bcList = this.broadcast();
		if(bcList[0]) document.getElementById("markerBackgroundColor").color = this.PREVIEW.style.backgroundColor;
		if(bcList[1]) document.getElementById("markerTextColor").color       = this.PREVIEW.style.color;

		if(bcList[2]){
			document.getElementById("markerBorderColor").color = this.PREVIEW.style.borderBottomColor;
			document.getElementById("markerBorderType").selectedIndex = this.PREVIEW.style.borderTop ? 0 : 1;

//			var elem = document.getElementsByAttribute("value", this.PREVIEW.style.borderBottomStyle);
//			document.getElementById("markerBorderStyle").selectedIndex = elem.length > 0 ? elem[0].getAttribute("index") : 0;
//			elem = document.getElementsByAttribute("value", this.PREVIEW.style.borderBottomWidth);
//			document.getElementById("markerBorderWidth").selectedIndex = elem.length > 0 ? elem[0].getAttribute("index") : 0;
			
			document.getElementById("markerBorderStyle").selectedIndex = 
				this.getMenulistSelectedIndex("markerBorderStyle", this.PREVIEW.style.borderBottomStyle);
			document.getElementById("markerBorderWidth").selectedIndex = 
				this.getMenulistSelectedIndex("markerBorderWidth", this.PREVIEW.style.borderBottomWidth);
		}
		if(bcList[3]){
			var elem = null;
			document.getElementById("iconPos").selectedIndex 			= iconInfo["iconPos"];
			document.getElementById("imageType").selectedIndex 			= iconInfo["imageType"];
			document.getElementById("preparedIconURL").selectedIndex 	= iconInfo["preparedIconURLIndex"];
			document.getElementById("customIconWidth").selectedIndex 	= iconInfo["customIconWidthIndex"];
			document.getElementById("customIconURL").value 				= iconInfo["customIconURL"];
		}
	},

	getMenulistSelectedIndex : function(elemName, searchValue){
//alert("getMenulistSelectedIndex");
		var selectedIndex = 0;
		elem = document.getElementById(elemName).firstChild;
		for(var i = 0; i < elem.childNodes.length; i++){
			if(elem.childNodes[i].getAttribute("value") == searchValue){
				selectedIndex = elem.childNodes[i].getAttribute("index");
				break;
			}
		}
		return selectedIndex;
	},

	parseToString : function(isPreview){
//alert("parseToString");
		var bcList = this.broadcast();
		var cssRules = [];
		
		// Icon Group
		if(bcList[3]){
			// padding size
			var padSize = "16px";
			if(document.getElementById("imageType").selectedIndex == 0){
				padSize = "16px";
			}else{
				if(document.getElementById("customIconWidth").selectedItem != -1){
					padSize = document.getElementById("customIconWidth").selectedItem.value;
				}
			}
			// Icon Position
			// Left
			if(document.getElementById("iconPos").selectedIndex == 0){
				cssRules.push("padding-left:" + padSize);
			// Right
			}else{
				cssRules.push("padding-right:" + padSize);
			}
			// Background
			var background_str = "background:transparent scroll no-repeat ";
			if(document.getElementById("iconPos").selectedIndex == 0){
				background_str += "top left ";
			}else{
				background_str += "bottom right ";
			}
			// Icon URL
			// Prepared Icon
			if(document.getElementById("imageType").selectedIndex == 0){
				var preparedIconURLElem = document.getElementById("preparedIconURL").selectedItem;
//				cssRules.push(background_str + "url(" + preparedIconURLElem.value + ")");
				cssRules.push(background_str + "url(" + preparedIconURLElem.getAttribute("image") + ")");
			// Custom Icon
			}else if(document.getElementById("imageType").selectedIndex == 1){
				var customIconURLElem = document.getElementById("customIconURL");
				cssRules.push(background_str + "url(" + customIconURLElem.value + ")");
			// Other
			}else{
				cssRules.push(background_str + "url(http://)");
			}
		}
		
		// BackgroudColor Group
		if(bcList[0]){
			var backgroundColor = document.getElementById("markerBackgroundColor").color || "none";
			if(backgroundColor != "none") cssRules.push("background-color:" + backgroundColor);
		}
		
		// Text Group
		if(bcList[1]){
			var textColor = document.getElementById("markerTextColor").color || "none";
			if(textColor != "none") cssRules.push("color:" + textColor);
			if(document.getElementById("markerTextBold").checked)   cssRules.push("font-weight:bold");
			if(document.getElementById("markerTextItalic").checked) cssRules.push("font-style:italic");
			if(document.getElementById("markerTextStrike").checked) cssRules.push("text-decoration:line-through");
		}
		
		// Border Group
		if(bcList[2]){
			var borderType  = document.getElementById("markerBorderType").selectedItem.value == "box" ? "border" : "border-bottom";
			var borderStyle = document.getElementById("markerBorderStyle").selectedItem.value;
			var borderWidth = document.getElementById("markerBorderWidth").selectedItem.value;
			var borderColor = document.getElementById("markerBorderColor").color || "none";
			if(borderColor != "none") cssRules.push(borderType + ":" + [borderWidth,borderStyle,borderColor].join(" "));
		}
		
		var styleStr =  cssRules.join(";");
		styleStr += styleStr ? ";" : "";
		
		var listElem = document.getElementById("markerSettingList");
		var itemElem = listElem.selectedItem;
		if(itemElem) itemElem.setAttribute("hidden", styleStr);
		if(isPreview){
			styleStr = window.opener.bitsHyperAnchor.convertURL2DataURL(styleStr);
		}
		return styleStr;
	},

	getIconStyle : function(cssText){
//alert("getIconStyle");
		if(!cssText) return new Array();
		var infoMap = new Array();
		var styles = cssText.split(';');

		for(var attrIdx = 0; attrIdx < styles.length; attrIdx++){
			var key_val = styles[attrIdx].split(':');
			
			if(key_val.length < 2) continue;
			
			var key = key_val[0];
			var val = key_val[1];
			for(var i = 2; i < key_val.length; i++){
				val += ":" + key_val[i];
			}
			key = this.trim(key);
			val = this.trim(val);
			if(key == "background"){
				infoMap["imageType"] = null;
				infoMap["preparedIconURLIndex"] = 0;
				infoMap["customIconURL"] = "";
				
				var URL = "";
				if(val.match(/url\(([\s\S]*?)\)/)){
					URL = RegExp.$1;
				}
				if(URL){
					var menuitems = document.getElementById("preparedIconURL").getElementsByTagName("menuitem");
					for(var i = 0; i < menuitems.length; i++){
//						if(menuitems[i].value == URL){
						if(menuitems[i].getAttribute("image") == URL){
							infoMap["imageType"] = 0;
							infoMap["preparedIconURLIndex"] = i;
							break;
						}
					}
					if(infoMap["imageType"] == null && URL.length > 0){
						infoMap["imageType"] = 1;
						infoMap["customIconURL"] = URL;
					}
					infoMap["iconEnabled"] = true;
				}

			}else if(key == "padding-right"){
				infoMap["iconPos"]  = 1;
				var menuitems = document.getElementById("customIconWidth").getElementsByTagName("menuitem");
				for(var i = 0; i < menuitems.length; i++){
					if(menuitems[i].value == val){
						infoMap["customIconWidthIndex"] = i;
						break;
					}
				}

			}else if(key == "padding-left"){
				infoMap["iconPos"]  = 0;
				var menuitems = document.getElementById("customIconWidth").getElementsByTagName("menuitem");
				for(var i = 0; i < menuitems.length; i++){
					if(menuitems[i].value == val){
						infoMap["customIconWidthIndex"] = i;
						break;
					}
				}
			}
		}
		return infoMap;
	},

	trim : function(argValue){
		return String(argValue).replace(/^[ 　]*/gim, "").replace(/[ 　]*$/gim, "");
	},
};
